#!/usr/bin/env python2
from __future__ import print_function
import time
import sys
import os

# while true; do cat stat | sed 's/ /\n/g' > /dev/shm/b; diff /dev/shm/a /dev/shm/b; cat /dev/shm/b > /dev/shm/a; sleep 1; done
# while true; do cat stat | cut -d' ' -f14,15 | while read a b; do echo "$a + $b = $(( a + b ))"; done; sleep 0.5; done
# ls -1 | grep -E '^[0-9]{1,9}' | sort -n | while read x; do echo -ne "$x   "; cat $x/stat | cut -d' ' -f22; done
# sleep 900 & sleep 0.5; pid=$(ps aux | grep 'sleep[ ]900' | sed 's/[^ ]*  *//;s/ .*//'); cat /proc/$pid/stat | cut -d' ' -f22; kill $pid



# config 
thr_top = 5
thr_time = 10000
debug = True
debug = False

# everybody loves globals
origo = int(time.time())
watching = []

# monitored process
class Inf:
	def __init__(self, total, tuser, tkern, memsz, origo, pid, name):
		self.total = total
		self.tuser = tuser
		self.tkern = tkern
		self.memsz = memsz
		self.origo = origo
		self.pid = pid
		self.name = name
		self.x_fn = None
		self.x_exe = None

def getproc(ppid):
	tuser = 0
	tkern = 0
	memsz = 0
	try:
		with open('/proc/%d/stat' % (ppid,), 'r') as f:
			stat = f.read()
		ofs1 = stat.index('(')
		ofs2 = stat.index(')')
		name = stat[ofs1+1:ofs2]
		name = name.split('/')[0]
		stat = stat[ofs2+2:].split(' ')
		origo = int(stat[19])

		tasks = os.listdir('/proc/%d/task' % (ppid,))
		for task in tasks:
			tid = int(task)
			if len(tasks) > 1 and tid == ppid:
				continue
			with open('/proc/%s/task/%s/stat' % (ppid,tid,), 'r') as f:
				stat = f.read()
			ofs2 = stat.index(')')
			stat = stat[ofs2+2:].split(' ')
			tuser += int(stat[11])
			tkern += int(stat[12])
			memsz += int(stat[20])
			#if ppid == 1722:
			#	print('%s=%s  ' % (tid,stat[11],), end='')
			#print('xxx %s / %s / %s = %s' % (ppid,tid,tuser,stat[11]))

		#if ppid == 1722:
		#	print()
		total = tuser + tkern
		return Inf(
			total, tuser, tkern, memsz, origo, ppid, name)
	except Exception as e:
		# died between listdir and here
		#print(sys.exc_traceback.tb_lineno)
		#print(e)
		return None

# get current list of processes, returns Inf's
def getprocs():
	pids = os.listdir('/proc')
	ret = []
	for spid in pids:
		try:
			pid = int(spid)
			#print("%d: " % (v,), end='')
		except:
			continue
		inf = getproc(pid)
		if inf is not None:
			ret.append(inf)
	return ret

if __name__ == '__main__':
	while True:
		with open('/proc/loadavg', 'r') as f:
			avg = f.read()
		avg = avg.split(' ')[0]

		ts = int(time.time())
		with open('loadavg', 'a') as f:
			f.write('%d %s\n' % (ts,avg,))

		procs = sorted(getprocs(), key=lambda x: x.total, reverse=True)
		unwatch = []

		# log cpu usage of all processes that we are monitoring
		for sec in range(0, 59):
			time.sleep(1)
			ts = int(time.time())
			for po in watching:
				if po in unwatch:
					continue

				now = getproc(po.pid)
				if now is None or now.origo != po.origo:
					if po not in unwatch:
						unwatch.append(po)
						print('xxx removing %s' % (po.name,))
					continue

				# filename; sessionOrigo-procName-procOrigo-procPid 
				if po.x_fn is None:
					po.x_fn = '%d-%s-%d-%d' % (origo,now.name,now.origo,now.pid,)

				if po.x_exe is None:
					with open('/proc/%d/cmdline' % (po.pid,), 'r') as f:
						po.x_exe = f.read().replace('\0', ' ')
					with open(po.x_fn, 'a') as f:
						f.write('+ %s\n' % (po.x_exe,))
					if debug:
						print('%s' % (po.x_exe,))

				tx = '%d %d %d %d %d %d\n' % (ts,
					now.total,
					now.tuser,
					now.tkern,
					#now.tuser - po.tuser,
					#now.tkern - po.tkern,
					now.memsz,
					now.total - po.total)

				with open(po.x_fn, 'a') as f:
					f.write(tx)

				if debug:
					print('%s => %s' % (po.x_fn,tx,), end='')
				po.total = now.total
				po.tuser = now.tuser
				po.tkern = now.tkern
				po.memsz = now.memsz

		for po in unwatch:
			watching.remove(po)

		# see if we need to monitor any additional processes
		# ('thr_top' consumers that are over 'thr_time' consumption)
		left = thr_top
		for proc in procs:
			if proc.total < thr_time:
				break
			left -= 1
			if left < 0:
				break
			found = None
			for old in watching:
				if old.pid == proc.pid and old.origo == proc.origo:
					found = old
					break
			if found is None:
				watching.append(proc)

		if debug:
			print('ayy')
			
